/**
 * Implementao de fila usando lista ligada (classe noListaLigada)
 * @author Lenidas O. Brando
 * @param
 * @return
 * @see 
 * */

public class listaFila {

  noListaLigada no_primeiro_fila = null;  // este elemento vai "apontar" para o primeiro da fila
  noListaLigada no_ultimo_fila   = null;  // este elemento vai "apontar" para ltimo da fila
  
  public listaFila () {
  }

  public void insere (Object obj) {
    noListaLigada novoNo = new noListaLigada( obj );
    if (no_primeiro_fila == null ) { // lista vazia
       no_primeiro_fila  = novoNo;
       no_ultimo_fila    = novoNo;
       }
    else
    if (no_ultimo_fila == no_primeiro_fila ) { // lista unitria
       no_primeiro_fila.proximo(novoNo);
       no_ultimo_fila          = novoNo;
       }
    else {
       no_ultimo_fila.proximo(novoNo); // penltimo agora aponta para novoNo
       no_ultimo_fila = no_ultimo_fila.proximo(); // avana ltimo
    }
  } 

  public Object remove () { // remove elemento ao final da fila
    if (no_primeiro_fila == null ) // lista vazia
       return null;

    Object ultimo_obj_da_fila = no_primeiro_fila.valor();
    if ( no_ultimo_fila == no_primeiro_fila ) { // lista unitria => remoo esvazia
       no_primeiro_fila = null;
       no_ultimo_fila   = null;
       }
    else { // encontre o anterior ao ltimo
      noListaLigada no_fila = no_primeiro_fila;
      while (  no_fila.proximo() != null ) // enquanto no apontar para ltimo
        no_fila = no_fila.proximo();
      no_ultimo_fila.proximo(null); // elimina o ltimo
      no_primeiro_fila = no_primeiro_fila.proximo();
      }
    return ultimo_obj_da_fila;
    }

  public void listaFila () {
    noListaLigada no_fila = no_primeiro_fila;
    while (  no_fila != null ) { // 
      System.out.print( " "+no_fila.valor() );
      no_fila = no_fila.proximo();
      }
    System.out.println( );
    }

}
